/* 室   25 ⮪ 嬠⭮ ᪨ ࠧ 5x5. . */

#include <cstdlib>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include <conio.h>

using namespace std;

const n=5;        // 嬠⭮ ᪨
const dx[10] = {0,  1,  2,  2,  1, -1, -2, -2, -1,  0};
const dy[10] = {0,  2,  1, -1, -2, -2, -1,  1,  2,  0};

int x[n*n+1];                   // ਧ⠫  k- 蠣, 1<=k<=n*n, 1<=x[k]<=n 
int y[n*n+1];                   // ਧ⠫  k- 蠣, 1<=k<=n*n, 1<=y[k]<=n 
int s[n*n+1];                   // ਠ 室  k- 蠣, 1<=k<=n*n, 1<=s[k]<=8
bool r[n+1][n+1];               // ⪨  ஬ p[x[k]][y[k]]  k- 蠣, 1<=k<=n*n
int u;                          // 襭
int c;                          //⢮ 室
short int zx[n*n+1][5000000];   //ᨢ ਧ⠫  室
short int zy[n*n+1][5000000];   //ᨢ ⨪  室
int m[1000];                    //室,  ஬ 祭 襭 

void knightpass();               //㭪 ᪠  襭   横
void record();                   // 室
void input(char *x0, char *y0);  // 
void output(char x0, char y0);   //뢮 १⮢.  

int main()
{ 
   char x0,  y0;
   input(&x0, &y0);
   u = 0; 
   c = 0;
   x[1] = x0-96;
   y[1] = y0-48;
   s[1] = 0;
   r[x[1]][y[1]] = true;
   knightpass();
   output(x0, y0);
   return 0;
}

void record()
{
   for (int j=1; j<=n*n; j++)   zx[j][c] = x[j];
   for (int j=1; j<=n*n; j++)   zy[j][c] = y[j];    
}

void knightpass()
{ 
   int k=0;
   while (1)
   {  
      k++;
      c++;
      record(); 
      if (k==n*n)  {u++;  m[u] = c;}    
      while(1)      
      {
         s[k]=s[k]+1;
         if ((r[x[k]+dx[s[k]]][y[k]+dy[s[k]]]==false) 
             && (x[k]+dx[s[k]]>=1) && (x[k]+dx[s[k]]<=n) && (y[k]+dy[s[k]]>=1) && (y[k]+dy[s[k]]<=n))
         {
             r[x[k]+dx[s[k]]][y[k]+dy[s[k]]] = true;  
             x[k+1] = x[k]+dx[s[k]];  
             y[k+1] = y[k]+dy[s[k]];
             s[k+1]  =0;
             break;
         }
         if (((s[k]==8)&&(r[x[k]+dx[8]][y[k]+dy[8]]==true))||((s[k]==9)&&(r[x[k]][y[k]]==true)))  
         {
            r[x[k]][y[k]] = false; 
            x[k] = 1;
            y[k] = 0;
            s[k] = 0;
            k--;
            c++;
            record(); 
            if (k==0)   return;  
            continue;
         }
      }
   }
}

void input(char *x0, char *y0)
{
   cout << " 室   " << n*n <<" ⮪ 嬠⭮ ᪨ ࠧ "<< n <<"x" << n <<". .\n"; 
   do
   {
     printf("   %d 㪢: a..%c:   ", n, 96+n);
     cin >> *x0;
   }
   while ((*x0 <'a')||(*x0>96+n)); 
   do
   {
     printf("   %d : 1..%c:   ", n, 48+n);
     cin >> *y0;
   }
   while ((*y0 <'1')||(*y0>48+n)); 
   for (int k=0; k<=n*n; k++) x[k] = 0;
   for (int k=0; k<=n*n; k++) y[k] = 0;
   for (int i=0; i<=n; i++) for (int j=0; j<=n; j++) r[i][j] = false;
}

void output(char x0, char y0)
{
   FILE *f;              //䠩  ࠭ १
   FILE *g;              //䠩  ࠭  室
   char fileout[15];     // 䠩  ࠭ १
   char fileoutall[20];  // 䠩  ࠭  室
   strcpy(fileout, "knight ");
   fileout[strlen(fileout)-1]=n+48;
   char v0[]="  ";
   v0[0]=x0; 
   v0[1]=y0;
   strcpy(fileout+strlen(fileout), v0);
   strcpy(fileoutall, fileout);
   strcpy(fileout+strlen(fileout), "z.htm");
   strcpy(fileoutall+strlen(fileoutall), "r_all.txt");
   unsigned char dk=34;  //窨
   f = fopen(fileout, "w");
   fprintf(f, "<html>\n");
   fprintf(f, "<head>\n");
   fprintf(f, "<title>\n");
   fprintf(f, "create html");
   fprintf(f, "</title>\n");
   fprintf(f, "<META http-equiv=Content-Type content=%ctext/html; charset=windows-1251%c>\n", dk, dk);
   fprintf(f, "</head>\n");
   fprintf(f, "<body>\n\n\n\n");
   fprintf(f, "The course of knight on chess board. <br>\n");
   fprintf(f, "The chess board have size %dx%d, %d fields. <br>\n", n, n, n*n);
   fprintf(f, "The first knight = ");  fprintf(f, v0);  fprintf(f, "<br>\n");
   fprintf(f, "The knight occupy every fields only one times. <br><br>\n\n");
   for (int i=1; i<=u; i++)
   {
      fprintf(f, "<pre>\n");
      fprintf(f,"The solution %3d, step = %6d\n", i, m[i]);
      for (int k=1; k<=n*n; k++) 
         fprintf(f, "%2d  %c%d  %2d\n", k, zx[k][m[i]]+96, zy[k][m[i]], n*(zx[k][m[i]]-1)+zy[k][m[i]]);
      fprintf(f,"\n");
      fprintf(f, "</pre>\n");
      int t[n+1][n+1];
      for (int k=1; k<=n*n; k++)
        for(int xt=1; xt<=n; xt++)
          for (int yt=1; yt<=n; yt++)
            if ((zx[k][m[i]]==xt)&&(zy[k][m[i]]==yt)) t[xt][yt]=k; 
      bool color = true;
      fprintf(f, "<table  cellspacing=%c1%c border=%c2%c ", dk, dk, dk, dk);
      fprintf(f, "bordercolor=%c#0000FF%c bgcolor=%c#0000FF%c>\n", dk, dk, dk, dk);
      for (int ys=n; ys>=1; ys--)
      {
         fprintf(f,"<tr>\n");
         for (int xs=1; xs<=n; xs++)
         {
            fprintf(f, "<td height=%c40%c width=%c40%c bgcolor=%c", dk, dk, dk, dk, dk);
            if (color==true) {fprintf(f,"#FFFF00");  color=false;}
            else {fprintf(f, "FF7F00");  color=true; } 
            fprintf(f, "%c><center>%d</center></td>\n", dk, t[xs][ys]);
         }
         fprintf(f,"</tr>\n");
      }
      fprintf(f, "</table><br><br>\n");
   }
   fprintf(f, "<pre>\n");  
   fprintf(f, "<font face=%cFixedsys%c>\n", dk, dk); 
   for (int i=1; i<=u; i++)
   { 
      fprintf(f, "%3d  ", i);
      for (int k=1; k<=n*n; k++) fprintf(f, "%c%d ", zx[k][m[i]]+96, zy[k][m[i]]);
      fprintf(f,"\n");
   }
   fprintf(f, "</font>\n"); 
   fprintf(f, "</pre>\n");
   if (u==0) fprintf(f, "There is no  solutions<br>\n");
   else fprintf(f, "Numbers of solutions =  %d<br>\n", u);
   fprintf(f, "The total numbers of steps =  %d<br>\n", c); 
   fprintf(f, "</body>\n");
   fprintf(f, "</html>\n");
   fclose(f);
   cout << " ᥣ ஡ 室 : "  << c <<'\n'; 
   if (u==0) cout << "襭 \n"; 
   else cout << "⢮ 襭 = " << u << '\n';   
   cout << "襭 ࠭  䠩 " << fileout  <<'\n'; 
   cout << "    ஡ 室    ᪥  200 " <<'\n';
   cout << "⢮ ப   ஡ 室 =  " << c << '\n'; 
   char st; 
   do
   {
     cout << "롥 㭪  1  2" <<'\n';
     cout << "1.   ᪥ 䠩 " << fileoutall <<"    ஡ 室" <<'\n';
     cout << "2.  ᮧ  ᪥ 䠩    ஡ 室 " <<'\n';
     cin >> st;
   }
   while ((st <'1')||(st>'2')); 
   if (st=='2') return; 
   if (st=='1')    
   {
      g = fopen(fileoutall, "w"); 
      cout << "   室  䠩\n" ;   
      for (int i=1; i<=c; i++)
      { 
         for (int k=1; k<=n*n; k++) if (zy[k][i]>0) fprintf(g, "%c%d ", zx[k][i]+96, zy[k][i]);
         fprintf(g,"\n");
      }
      fprintf(g, "\nThe total numbers of steps =  %d\n\n", c);
      if (u==0) fprintf(g, "There is no  solutions\n");
      else fprintf(g, "Numbers of solutions =  %d\n\n", u);
      for (int i=1; i<=u; i++)
      { 
         fprintf(g, "%3d  ", i);
         for (int k=1; k<=n*n; k++) fprintf(g, "%c%d ", zx[k][m[i]]+96, zy[k][m[i]]);
         fprintf(g,"\n");
      }
      fclose(g);
      cout << " ࠭  䠩 " << fileoutall  <<'\n'; 
      getch();
   }
}
